/*
Nombre:   Gateway_X_Remoto
Sintaxis: gxr <IP_Servidor_X>
Descripcion: Recibe conexiones desde un cliente X remoto y luego contacta el servidor X
             indicado el argumento
*/
#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>


#define MAXHOSTNAME 80

int sfd,xfd,n,s,i,psd,largo;       /*descriptores de archivo para los sockets servidor y para el  servidor X*/

int sock;
	struct   sockaddr_in server;
	struct   sockaddr_in xserver,from;
	fd_set readfds, readfdsCopy;

int conexion(int u,int v);
int conexion1(int u, int v);

void reusePort(int s){
        int one=1;

        if ( setsockopt(s,SOL_SOCKET,SO_REUSEADDR,(char *) &one,sizeof(one)) == -1 ){
                printf("error in setsockopt,SO_REUSEPORT \n");
                exit(-1);
        }
}

int main (int argc,char *argv[]){

	struct  hostent *hp,*hp1, *gethostbyname();

	int fromlen;
	int length;
	char ThisHost[MAXHOSTNAME];
        largo=sizeof(argv[1]);
	if (argc !=2){
		printf("ingrese el numero IP\n");
		exit(0);
	}
	gethostname(ThisHost, MAXHOSTNAME);
	if  ( (hp = gethostbyname(ThisHost)) == NULL ) {
		fprintf(stderr, "host no encontrado %s\n", ThisHost);
		exit(-1);
	}

/*               Aqui se completan las estructiras del servidor creado      */

	bcopy ( hp->h_addr, &(server.sin_addr), hp->h_length);
	server.sin_family = AF_INET;
	server.sin_port = htons(6001);
	sfd = socket (hp->h_addrtype,SOCK_STREAM,0);

	if (sfd<0) {
		perror("opening stream socket");
		exit(-1);
	}
	reusePort(sfd);

	if ( bind( sfd, (struct sockaddr *) &server, sizeof(server) ) ) {
		close(sfd);
		perror("binding name to stream socket");
		exit(-1);
	}

/*               Aqui se completan las estructuras del servidor creado      */

	if  ( (hp1 = gethostbyname(argv[1])) == NULL ) {
		fprintf(stderr, "host no encontrado %s\n", ThisHost);
		exit(-1);
	}
	bcopy ( hp1->h_addr, &(xserver.sin_addr), hp1->h_length);
	xserver.sin_family = AF_INET;
	xserver.sin_port = htons(6000);
	xfd = socket (AF_INET,SOCK_STREAM,0);
	listen(sfd,4);
	fromlen = sizeof(xserver);
	FD_ZERO(&readfdsCopy);
	FD_SET(sfd,&readfdsCopy);
	if ( connect(xfd, (struct sockaddr *)&xserver, sizeof(xserver)) < 0 ) {
		close(xfd);
		perror("connecting stream socket");
		exit(0);
	}
	for(;;){
		memcpy(&readfds, &readfdsCopy, sizeof(fd_set));
		n = select(FD_SETSIZE, &readfds, (fd_set *) 0, (fd_set *) 0, NULL);
		if (n > 0) {
			if (FD_ISSET(sfd, &readfds)) {
				printf("Accepting a new connection...\n");
				sock = accept(sfd, (struct sockaddr *)&from, &fromlen);
				FD_SET(sock, &readfdsCopy);
				FD_SET(xfd,&readfdsCopy);
			}
			if (FD_ISSET(sock, &readfds)){
			        conexion(sock,xfd);
                        }
			if (FD_ISSET(xfd, &readfds)){
                                conexion(xfd,sock);
                        }
		}

	}
}


int conexion(int u,int v){

	char buf[1024];
	int rc,aux;
	if((rc=recv(u, buf, sizeof(buf),0))>0){
	buf[rc]='\0';
	send(v, buf, rc, 0);
	}else{
		close(u);
		close(v);
	 exit(0);
	 }
}
